/*******************************************************************************
 * BlåtAnt Algorithm Evaluation Platform
 * 
 * Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 * 					Pervasive and Artificial Intelligence Research Group
 * 					Department of Informatics DIUF
 * 					University of Fribourg, Fribourg
 * 					Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************/
package ants;

import support.NetworkSystem;
import support.Stats;

public class UnlinkAnt extends Ant {

	private String target = null;
	private int step = 0;

	public UnlinkAnt(String id, String target) {
		super(id);
		this.target = target;
	}

	public void antstep() {
		if (!NetworkSystem.isNodeAlive(current_)) {
			// We are on a dead node
			kill();
			return;
		}
		current.acquire();
		switch (step) {
		case 0:
			current.release();
			if (!migrate(target)) {
				step = 4;
				kill();
				return;
			} else {
				step = 1;
			}
			return;
		case 1:
			// tell();
			if (!current.disconnect(source)) {
			}
			step = 4;
			current.release();
			kill();
			return;
		default:
		}
	}

	public void reset(String id, String target) {
		super.reset(id);
		this.target = target;
		step = 0;
	}

	public void reset(String id, String target, String other) {
		reset(id, target);
	}

	@Override
	public void statmigration() {
		Stats.antMigration(UnlinkAnt.class, 0);
	}

}
