/*******************************************************************************
 * BlåtAnt Algorithm Evaluation Platform
 * 
 * Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 * 					Pervasive and Artificial Intelligence Research Group
 * 					Department of Informatics DIUF
 * 					University of Fribourg, Fribourg
 * 					Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************/
/**
 *  Solenopsis: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006  Amos Brocco <amos.brocco@unifr.ch>
 *  					Pervasive and Artificial Intelligence Research Group
 *  					Department of Informatics DIUF
 *  					University of Fribourg, Fribourg
 *  					Switzerland
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
package cli;

public class SwitchOption extends CLIOption<Boolean> {

	private String description;
	private String shortLabel;
	private String longLabel;
	private boolean value;
	private boolean defaultValue;

	public SwitchOption(String shortL, String longL, String desc) {
		shortLabel = shortL;
		longLabel = longL;
		defaultValue = false;
		value = false;
		description = desc;
	}

	public String getDefault() {
		return new Boolean(defaultValue).toString();
	}

	public String getDescription() {
		return description;
	}

	public String getLongLabel() {
		return longLabel;
	}

	public String getShortLabel() {
		return shortLabel;
	}

	public int getSkip() {
		return 1;
	}

	public void setValue(String string) {
		value = true;
	}

	public Boolean getValue() {
		isused = true;
		return value;
	}

	private boolean isused = false;

	public boolean used() {
		return isused;
	}

	public boolean isMandatory() {
		return false;
	}

	public String getType() {
		return "n/a";
	}

	public boolean ignoreInvalid() {
		return true;
	}

	public boolean isValidValue(String value) {
		return true;
	}

}
