/*******************************************************************************
 * BlåtAnt Algorithm Evaluation Platform
 * 
 * Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 * 					Pervasive and Artificial Intelligence Research Group
 * 					Department of Informatics DIUF
 * 					University of Fribourg, Fribourg
 * 					Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************/
package net;

import java.util.Map;
import java.util.Observable;
import java.util.Observer;

import bebop.buffer.Buffer;
import bebop.lib.IMessage;

public class NetworkInterface implements Observer {

	private Buffer incomingBuffer;
	//private BlatAntNest nest;

	public NetworkInterface(BlatAntNest n) {

	}

	public void update(Observable source, Object data) {
		if (source == incomingBuffer) {
			IMessage msg = incomingBuffer.popMessage();
			if (msg != null) {
				processMessage(msg);
			}
		}
	}

	/*private void migrateAnt(String destination, Map<String, Object> contents) {
		// TODO

		// 1. Save the current node id as "source"
		contents.put("source", nest.getIdentifier());
		// 2. Create a message to store the ant

		// 3. Send the message to the recipient

		// 4. Increase the corresponding gamma pheromone

	}*/

	private void processMessage(IMessage msg) {
		Map<String, Object> contents = msg.getContents();
		if ("discovery".equals(contents.get("ant"))) {
			doDiscovery(contents);
		} else if ("constructionlink".equals(contents.get("ant"))) {
			doConstructionLink(contents);
		} else if ("optimizationlink".equals(contents.get("ant"))) {
			doOptimizationLink(contents);
		} else if ("unlink".equals(contents.get("ant"))) {
			doUnlink(contents);
		} else if ("ping".equals(contents.get("ant"))) {
			doPing(contents);
		} else if ("query".equals(contents.get("ant"))) {
			doQuery(contents);
		}
	}

	private void doQuery(Map<String, Object> contents) {
		//Integer step = (Integer) contents.get("step");
		// TODO Auto-generated method stub

	}

	private void doPing(Map<String, Object> contents) {
		//Integer step = (Integer) contents.get("step");
		// TODO Auto-generated method stub

	}

	private void doUnlink(Map<String, Object> contents) {
		//Integer step = (Integer) contents.get("step");
		// TODO Auto-generated method stub

	}

	private void doOptimizationLink(Map<String, Object> contents) {
		//Integer step = (Integer) contents.get("step");
		// TODO Auto-generated method stub

	}

	private void doConstructionLink(Map<String, Object> contents) {
		//Integer step = (Integer) contents.get("step");
		// TODO Auto-generated method stub

	}

	private void doDiscovery(Map<String, Object> contents) {
		//Integer step = (Integer) contents.get("step");
		// TODO Auto-generated method stub

	}

}
