/*******************************************************************************
 * BlåtAnt Algorithm Evaluation Platform
 * 
 * Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 * 					Pervasive and Artificial Intelligence Research Group
 * 					Department of Informatics DIUF
 * 					University of Fribourg, Fribourg
 * 					Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************/
package services;

import java.util.HashMap;
import java.util.UUID;

public class ContentStreaming {
	
	class Stream {
		
		private UUID uuid;
		
		private HashMap<String,Long> sources; // neighborId -> last seq number
		
		public Stream(UUID streamId) {
			this.uuid = streamId;
		}
		
		public void addSource(String id, Long seq) {
			sources.put(id, seq);
		}
		
		public void removeSource(String id) {
			sources.remove(id);
		}
		
		public Long getSequence(String id) {
			if (!sources.containsKey(id)) return -1l;
			return sources.get(id);
		}
		
		public UUID getUUID() {
			return uuid;
		}
	}
	
	
	public void incomingData(UUID streamId, String sender, long seq, Object data) {
		
	}
	
	@SuppressWarnings("unused")
	private void forward(UUID streamId, long seq, Object data) {
		
	}
	
	

}
