/*******************************************************************************
 * BlåtAnt Algorithm Evaluation Platform
 * 
 * Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 * 					Pervasive and Artificial Intelligence Research Group
 * 					Department of Informatics DIUF
 * 					University of Fribourg, Fribourg
 * 					Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************/
package services;

import java.util.Collection;

import messages.Message;


public interface IInformationSystemService {
	
	//public void setCache(InformationSystemEntry[] cache);
	
	public String getIdentifier();
	
	public InformationSystemEntry[] getCacheClone();
	
	public void pushPeer (String n, long ts);
	
	public void replaceCacheWith(InformationSystemEntry[] c);
	
	public void timestep();
	
	public boolean processQuery (Message query, int ttl);
	
	public Collection<String> getCacheIdentifiers();
	
	public long getMergeInterval();
	
	public long getProactiveInterval();
	
	public int getCacheSize();
	
	public void cleanup();

	public long getTime();

}
