/*******************************************************************************
 * BlåtAnt Algorithm Evaluation Platform
 * 
 * Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 * 					Pervasive and Artificial Intelligence Research Group
 * 					Department of Informatics DIUF
 * 					University of Fribourg, Fribourg
 * 					Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************/
package services;

import pheromone.Pheromone;
import support.INetworkNode;
import support.Randomizer;
import support.Stats;

public class LoadManagementService implements ILoadManagementService {

	private double load = Randomizer.pop() * 100;
	private INetworkNode node;
	private Pheromone stigma;

	public LoadManagementService(INetworkNode node) {
		this.node = node;
		stigma = new Pheromone("stigma", node.getIdentifier());
		setLoad(Randomizer.pop() * 100);
	}

	public void setLoad(double value) {
		load = value;
		Stats.tellLoad(node.getIdentifier(), load);
	}

	public double getLoad() {
		return load;
	}

	public Pheromone getStigma() {
		return stigma;
	}

}
