/*******************************************************************************
 * BlåtAnt Algorithm Evaluation Platform
 * 
 * Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 * 					Pervasive and Artificial Intelligence Research Group
 * 					Department of Informatics DIUF
 * 					University of Fribourg, Fribourg
 * 					Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************/
package services;

public class MathUtils {
	
	public static double average(int[] values, int startIndex) {
		double total = 0;
		for (int i=startIndex; i<values.length;i++) {
			total += values[i];
		}
		return total / (values.length - startIndex);
	}
	
	public static double stdev(Double average, int[] values, int startIndex) {
		double t = 0;
		for (int i=startIndex; i<values.length;i++) {
			t += Math.pow(values[i] - average, 2);
		}
		return Math.sqrt(t / (values.length - startIndex));
	}
	


}
