/*******************************************************************************
 * BlåtAnt Algorithm Evaluation Platform
 * 
 * Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 * 					Pervasive and Artificial Intelligence Research Group
 * 					Department of Informatics DIUF
 * 					University of Fribourg, Fribourg
 * 					Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************/
package support;

import java.util.Hashtable;

public class Testbed {

	private double similarity(String a, String b) {
		int ahash = a.hashCode() & 255;
		int bhash = b.hashCode() & 255;
		if (ahash == bhash)
			return 1f;
		else
			return (new Double(Math.abs(ahash - bhash)).doubleValue() / 256f);
	}

	public Hashtable<Integer, Integer> klasses = new Hashtable<Integer, Integer>();

	public void addToClass(Integer klass) {
		if (klasses.containsKey(klass)) {
			int value = klasses.get(klass);
			klasses.put(klass, value + 1);
		} else {
			klasses.put(klass, 1);
		}
	}

	public Testbed() {

		double threshold = 0.7f;

		for (int j = 0; j < 1281; j++) {
			int count = 0;
			for (Integer i = 0; i < 1281; i++) {
				double simi = similarity(Integer.toString(j), i.toString());
				if (simi > threshold) {
					count++;
				}
			}
			addToClass(count);
		}

		for (Integer t : klasses.keySet()) {
			System.out.println(klasses.get(t) + " items have " + t
					+ " similars");
		}

		System.out.println("Total of " + klasses.size() + " classes");
	}

	public static void main(String[] args) {
		new Testbed();
	}

}
