/*******************************************************************************
 * BlåtAnt Algorithm Evaluation Platform
 * 
 * Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 * 					Pervasive and Artificial Intelligence Research Group
 * 					Department of Informatics DIUF
 * 					University of Fribourg, Fribourg
 * 					Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************/
package util;

import java.io.OutputStream;
import java.io.PrintStream;

public class LogPrintStream extends PrintStream {

	protected PrintStream b;
	
	public LogPrintStream(OutputStream out, PrintStream base) {
		super(out);
		b = base;
	}
	
	public void println(String s) {
		b.println(s);
		super.println(s);
	}
	
	public void println() {
		b.println();
		super.println();
	}
	
	public PrintStream format(String s, Object... o) {
		b.format(s, o);
		return super.format(s, o);
	}
	
	
	
	

}
